/* Generated automatically by the program `genattrtab'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "options.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-attr.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "regs.h"
#include "real.h"
#include "output.h"
#include "toplev.h"
#include "flags.h"
#include "emit-rtl.h"

#define operands recog_data.operand

int
insn_current_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_variable_length_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

int
insn_min_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 14:  /* *movsf_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 4;
        }
      else if (which_alternative == 1)
        {
	  return 8;
        }
      else
        {
	  return 4;
        }

    case 13:  /* *movv8qi_insn */
    case 12:  /* *movv4hi_insn */
    case 11:  /* *movv2sf_insn */
    case 10:  /* *movv2si_insn */
    case 9:  /* *movdf_insn */
    case 8:  /* *movdi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 8;
        }
      else if (which_alternative == 1)
        {
	  return 16 /* 0x10 */;
        }
      else
        {
	  return 4;
        }

    case 6:  /* *movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0xf))
        {
	  return 4;
        }
      else if (which_alternative == 4)
        {
	  return 8;
        }
      else
        {
	  return 4;
        }

    case 110:  /* *fmaddv2sf_combine */
    case 109:  /* *fmaddv2si_combine */
    case 108:  /* mulv2sf3_i */
    case 107:  /* mulv2si3_i */
    case 106:  /* *ashlv2si3_i */
    case 105:  /* subv2sf3_i */
    case 104:  /* addv2sf3_i */
    case 103:  /* xorv2si3 */
    case 102:  /* iorv2si3 */
    case 101:  /* andv2si3 */
    case 100:  /* subv2si3 */
    case 99:  /* addv2si3 */
      return 8;

    case 46:  /* *movcc_i */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 20 /* 0x14 */;
        }
      else
        {
	  return 4;
        }

    case 42:  /* *umodsi3_1 */
    case 40:  /* *modsi3_1 */
    case 38:  /* *udivsi3_1 */
    case 36:  /* *divsi3_1 */
    case 22:  /* *recipsf2_1 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 16 /* 0x10 */;
        }
      else
        {
	  return 24 /* 0x18 */;
        }

    case 16:  /* addsi3_r */
      return 20 /* 0x14 */;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 4;

    }
}

int
insn_default_length (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 14:  /* *movsf_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 4;
        }
      else if (which_alternative == 1)
        {
	  return 8;
        }
      else
        {
	  return 4;
        }

    case 13:  /* *movv8qi_insn */
    case 12:  /* *movv4hi_insn */
    case 11:  /* *movv2sf_insn */
    case 10:  /* *movv2si_insn */
    case 9:  /* *movdf_insn */
    case 8:  /* *movdi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 8;
        }
      else if (which_alternative == 1)
        {
	  return 16 /* 0x10 */;
        }
      else
        {
	  return 4;
        }

    case 6:  /* *movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0xf))
        {
	  return 4;
        }
      else if (which_alternative == 4)
        {
	  return 8;
        }
      else
        {
	  return 4;
        }

    case 110:  /* *fmaddv2sf_combine */
    case 109:  /* *fmaddv2si_combine */
    case 108:  /* mulv2sf3_i */
    case 107:  /* mulv2si3_i */
    case 106:  /* *ashlv2si3_i */
    case 105:  /* subv2sf3_i */
    case 104:  /* addv2sf3_i */
    case 103:  /* xorv2si3 */
    case 102:  /* iorv2si3 */
    case 101:  /* andv2si3 */
    case 100:  /* subv2si3 */
    case 99:  /* addv2si3 */
      return 8;

    case 46:  /* *movcc_i */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 20 /* 0x14 */;
        }
      else
        {
	  return 4;
        }

    case 42:  /* *umodsi3_1 */
    case 40:  /* *modsi3_1 */
    case 38:  /* *udivsi3_1 */
    case 36:  /* *divsi3_1 */
    case 22:  /* *recipsf2_1 */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return 16 /* 0x10 */;
        }
      else
        {
	  return 24 /* 0x18 */;
        }

    case 16:  /* addsi3_r */
      return 20 /* 0x14 */;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 4;

    }
}

int
bypass_p (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_pipe_model cached_pipe_model ATTRIBUTE_UNUSED;
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 111:  /* nop */
    case 105:  /* subv2sf3_i */
    case 104:  /* addv2sf3_i */
    case 103:  /* xorv2si3 */
    case 102:  /* iorv2si3 */
    case 101:  /* andv2si3 */
    case 100:  /* subv2si3 */
    case 99:  /* addv2si3 */
    case 97:  /* stack_adjust_str */
    case 94:  /* return_internal_interrupt */
    case 93:  /* return_i */
    case 92:  /* *sibcall_value_i */
    case 91:  /* *call_value_i */
    case 90:  /* *sibcall_i */
    case 89:  /* *call_i */
    case 88:  /* *tablejump_hi_internal */
    case 87:  /* *tablejump_internal */
    case 86:  /* indirect_jump */
    case 85:  /* jump */
    case 84:  /* *rev_branch_insn */
    case 83:  /* branch_insn */
    case 76:  /* *cmpsf_uneq */
    case 75:  /* *cmpsf_ord */
    case 74:  /* *cmpsf_gte */
    case 73:  /* *cmpsf_eq */
    case 46:  /* *movcc_i */
    case 45:  /* gie */
    case 44:  /* gid */
    case 43:  /* *umodsi3_2 */
    case 42:  /* *umodsi3_1 */
    case 41:  /* *modsi3_2 */
    case 40:  /* *modsi3_1 */
    case 39:  /* *udivsi3_2 */
    case 38:  /* *udivsi3_1 */
    case 37:  /* *divsi3_2 */
    case 36:  /* *divsi3_1 */
    case 23:  /* *recipsf2_2 */
    case 22:  /* *recipsf2_1 */
    case 16:  /* addsi3_r */
      return 0;

    case 14:  /* *movsf_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x5))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 13:  /* *movv8qi_insn */
    case 12:  /* *movv4hi_insn */
    case 11:  /* *movv2sf_insn */
    case 10:  /* *movv2si_insn */
    case 9:  /* *movdf_insn */
    case 8:  /* *movdi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 2)
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 6:  /* *movsi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x2f))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 2:  /* *movhi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x7))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case 1:  /* *movqi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0xf))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if (((cached_pipe_model = get_attr_pipe_model (insn)) == PIPE_MODEL_EPIPHANY) && (((cached_type = get_attr_type (insn)) == TYPE_MOVE) || (cached_type == TYPE_CMOVE) || (cached_type == TYPE_COMPARE) || (cached_type == TYPE_SHIFT) || (cached_type == TYPE_MISC) || (cached_type == TYPE_MUL)) && (get_attr_length (insn) == 4))
        {
	  return 1;
        }
      else if ((cached_pipe_model == PIPE_MODEL_EPIPHANY) && ((cached_type = get_attr_type (insn)) == TYPE_LOAD))
        {
	  return 1;
        }
      else if ((cached_pipe_model == PIPE_MODEL_EPIPHANY) && (((cached_type = get_attr_type (insn)) == TYPE_FP) || (cached_type == TYPE_FP_INT)))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    default:
      return 1;

    }
}

int
num_delay_slots (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return 0;

    }
}

enum attr_fp_mode
get_attr_fp_mode (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 92:  /* *sibcall_value_i */
    case 91:  /* *call_value_i */
    case 90:  /* *sibcall_i */
    case 89:  /* *call_i */
      extract_constrain_insn_cached (insn);
      return 
#line 85 "../../gcc/config/epiphany/epiphany.md"
((enum attr_fp_mode) epiphany_normal_fp_mode);

    case 110:  /* *fmaddv2sf_combine */
    case 108:  /* mulv2sf3_i */
    case 105:  /* subv2sf3_i */
    case 104:  /* addv2sf3_i */
    case 43:  /* *umodsi3_2 */
    case 42:  /* *umodsi3_1 */
    case 41:  /* *modsi3_2 */
    case 40:  /* *modsi3_1 */
    case 39:  /* *udivsi3_2 */
    case 38:  /* *udivsi3_1 */
    case 37:  /* *divsi3_2 */
    case 36:  /* *divsi3_1 */
    case 29:  /* *floatsisf2_cmp_i */
    case 28:  /* *floatsisf2_i */
    case 27:  /* *fmsub_combine */
    case 26:  /* *fmsub */
    case 25:  /* *maddsf_combine */
    case 24:  /* *fmadd */
    case 23:  /* *recipsf2_2 */
    case 22:  /* *recipsf2_1 */
    case 21:  /* *mulsf3_i */
    case 20:  /* *subsf3_f_i */
    case 19:  /* *subsf3_i */
    case 18:  /* *addsf3_i */
      extract_constrain_insn_cached (insn);
      return 
#line 83 "../../gcc/config/epiphany/epiphany.md"
((enum attr_fp_mode) epiphany_normal_fp_rounding);

    case 30:  /* *fix_truncsfsi2_i */
      extract_constrain_insn_cached (insn);
      if (
#line 945 "../../gcc/config/epiphany/epiphany.md"
(TARGET_MAY_ROUND_FOR_TRUNC))
        {
	  return FP_MODE_ROUND_UNKNOWN;
        }
      else
        {
	  return FP_MODE_ROUND_TRUNC;
        }

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      extract_constrain_insn_cached (insn);
      if (((cached_type = get_attr_type (insn)) == TYPE_FP) || (cached_type == TYPE_V2FP) || (cached_type == TYPE_FP_SFUNC))
        {
	  return 
#line 83 "../../gcc/config/epiphany/epiphany.md"
((enum attr_fp_mode) epiphany_normal_fp_rounding);
        }
      else if (cached_type == TYPE_CALL)
        {
	  return 
#line 85 "../../gcc/config/epiphany/epiphany.md"
((enum attr_fp_mode) epiphany_normal_fp_mode);
        }
      else if (cached_type == TYPE_FP_INT)
        {
	  return FP_MODE_INT;
        }
      else
        {
	  return FP_MODE_NONE;
        }

    case 109:  /* *fmaddv2si_combine */
    case 107:  /* mulv2si3_i */
    case 106:  /* *ashlv2si3_i */
    case 35:  /* *imsub */
    case 34:  /* *maddsi_combine */
    case 33:  /* *imul */
    case 32:  /* *isub_i */
    case 31:  /* *iadd_i */
      return FP_MODE_INT;

    case 72:  /* *cmpsf_cc_insn */
      return FP_MODE_ROUND_UNKNOWN;

    default:
      return FP_MODE_NONE;

    }
}

enum attr_pipe_model
get_attr_pipe_model (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return PIPE_MODEL_EPIPHANY;

    }
}

enum attr_rounding
get_attr_rounding (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      extract_constrain_insn_cached (insn);
      if ((
#line 77 "../../gcc/config/epiphany/epiphany.md"
(TARGET_ROUND_NEAREST)) != (0))
        {
	  return ROUNDING_NEAREST;
        }
      else
        {
	  return ROUNDING_TRUNC;
        }

    }
}

int
get_attr_sched_use_fpu (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  enum attr_type cached_type ATTRIBUTE_UNUSED;

  switch (recog_memoized (insn))
    {
    case 110:  /* *fmaddv2sf_combine */
    case 109:  /* *fmaddv2si_combine */
    case 108:  /* mulv2sf3_i */
    case 107:  /* mulv2si3_i */
    case 106:  /* *ashlv2si3_i */
    case 105:  /* subv2sf3_i */
    case 104:  /* addv2sf3_i */
    case 72:  /* *cmpsf_cc_insn */
    case 35:  /* *imsub */
    case 34:  /* *maddsi_combine */
    case 33:  /* *imul */
    case 32:  /* *isub_i */
    case 31:  /* *iadd_i */
    case 30:  /* *fix_truncsfsi2_i */
    case 29:  /* *floatsisf2_cmp_i */
    case 28:  /* *floatsisf2_i */
    case 27:  /* *fmsub_combine */
    case 26:  /* *fmsub */
    case 25:  /* *maddsf_combine */
    case 24:  /* *fmadd */
    case 21:  /* *mulsf3_i */
    case 20:  /* *subsf3_f_i */
    case 19:  /* *subsf3_i */
    case 18:  /* *addsf3_i */
      return 1;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
      if (((cached_type = get_attr_type (insn)) == TYPE_FP) || (cached_type == TYPE_FP_INT) || (cached_type == TYPE_V2FP))
        {
	  return 1;
        }
      else
        {
	  return 0;
        }

    default:
      return 0;

    }
}

enum attr_type
get_attr_type (rtx_insn *insn ATTRIBUTE_UNUSED)
{
  switch (recog_memoized (insn))
    {
    case 6:  /* *movsi_insn */
      extract_constrain_insn_cached (insn);
      if (which_alternative == 0)
        {
	  return TYPE_MOVE;
        }
      else if (((1 << which_alternative) & 0xe))
        {
	  return TYPE_MISC;
        }
      else if (which_alternative == 4)
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 5)
        {
	  return TYPE_LOAD;
        }
      else if (which_alternative == 6)
        {
	  return TYPE_STORE;
        }
      else
        {
	  return TYPE_FLOW;
        }

    case 14:  /* *movsf_insn */
    case 13:  /* *movv8qi_insn */
    case 12:  /* *movv4hi_insn */
    case 11:  /* *movv2sf_insn */
    case 10:  /* *movv2si_insn */
    case 9:  /* *movdf_insn */
    case 8:  /* *movdi_insn */
    case 2:  /* *movhi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x3))
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 2)
        {
	  return TYPE_LOAD;
        }
      else
        {
	  return TYPE_STORE;
        }

    case 1:  /* *movqi_insn */
      extract_constrain_insn_cached (insn);
      if (((1 << which_alternative) & 0x7))
        {
	  return TYPE_MOVE;
        }
      else if (which_alternative == 3)
        {
	  return TYPE_LOAD;
        }
      else
        {
	  return TYPE_STORE;
        }

    case 44:  /* gid */
    case 45:  /* gie */
    case 46:  /* *movcc_i */
    case 111:  /* nop */
      return TYPE_FLOW;

    case 22:  /* *recipsf2_1 */
    case 23:  /* *recipsf2_2 */
    case 36:  /* *divsi3_1 */
    case 37:  /* *divsi3_2 */
    case 38:  /* *udivsi3_1 */
    case 39:  /* *udivsi3_2 */
    case 40:  /* *modsi3_1 */
    case 41:  /* *modsi3_2 */
    case 42:  /* *umodsi3_1 */
    case 43:  /* *umodsi3_2 */
      return TYPE_FP_SFUNC;

    case 73:  /* *cmpsf_eq */
    case 74:  /* *cmpsf_gte */
    case 75:  /* *cmpsf_ord */
    case 76:  /* *cmpsf_uneq */
      return TYPE_SFUNC;

    case 104:  /* addv2sf3_i */
    case 105:  /* subv2sf3_i */
      return TYPE_V2FP;

    case 31:  /* *iadd_i */
    case 32:  /* *isub_i */
    case 33:  /* *imul */
    case 34:  /* *maddsi_combine */
    case 35:  /* *imsub */
    case 106:  /* *ashlv2si3_i */
    case 107:  /* mulv2si3_i */
    case 109:  /* *fmaddv2si_combine */
      return TYPE_FP_INT;

    case 18:  /* *addsf3_i */
    case 19:  /* *subsf3_i */
    case 20:  /* *subsf3_f_i */
    case 21:  /* *mulsf3_i */
    case 24:  /* *fmadd */
    case 25:  /* *maddsf_combine */
    case 26:  /* *fmsub */
    case 27:  /* *fmsub_combine */
    case 28:  /* *floatsisf2_i */
    case 29:  /* *floatsisf2_cmp_i */
    case 30:  /* *fix_truncsfsi2_i */
    case 72:  /* *cmpsf_cc_insn */
    case 108:  /* mulv2sf3_i */
    case 110:  /* *fmaddv2sf_combine */
      return TYPE_FP;

    case 89:  /* *call_i */
    case 90:  /* *sibcall_i */
    case 91:  /* *call_value_i */
    case 92:  /* *sibcall_value_i */
      return TYPE_CALL;

    case 83:  /* branch_insn */
    case 84:  /* *rev_branch_insn */
      return TYPE_BRANCH;

    case 85:  /* jump */
    case 86:  /* indirect_jump */
    case 87:  /* *tablejump_internal */
    case 88:  /* *tablejump_hi_internal */
    case 93:  /* return_i */
    case 94:  /* return_internal_interrupt */
      return TYPE_UNCOND_BRANCH;

    case 53:  /* ashrsi3 */
    case 54:  /* ashrsi3_tst */
    case 55:  /* lshrsi3 */
    case 56:  /* lshrsi3_tst */
    case 57:  /* ashlsi3 */
      return TYPE_SHIFT;

    case 61:  /* cmpsi_cc_insn */
    case 62:  /* sub_f */
    case 63:  /* *sub_f_add_imm */
    case 64:  /* *add_c */
    case 65:  /* *add_c_rev */
    case 66:  /* *sub_c */
    case 67:  /* *sub_c_void */
    case 68:  /* *and_f */
    case 69:  /* *orr_f */
    case 70:  /* *eor_f */
    case 71:  /* *mov_f */
      return TYPE_COMPARE;

    case 77:  /* *movsicc_insn */
    case 78:  /* *movsfcc_insn */
    case 79:  /* *movhicc_insn */
    case 80:  /* *movqicc_insn */
    case 81:  /* *movv2hicc_insn */
    case 82:  /* *movv4qicc_insn */
      return TYPE_CMOVE;

    case 97:  /* stack_adjust_str */
      return TYPE_STORE;

    case 98:  /* stack_adjust_ldr */
      return TYPE_LOAD;

    case 4:  /* movsi_high */
    case 5:  /* movsi_lo_sum */
    case 96:  /* stack_adjust_mov */
      return TYPE_MOVE;

    case -1:
      if (GET_CODE (PATTERN (insn)) != ASM_INPUT
          && asm_noperands (PATTERN (insn)) < 0)
        fatal_insn_not_found (insn);
      /* FALLTHRU */
    default:
      return TYPE_MISC;

    }
}

int
eligible_for_delay (rtx_insn *delay_insn ATTRIBUTE_UNUSED, int slot, 
		   rtx_insn *candidate_insn, int flags ATTRIBUTE_UNUSED)
{
  rtx_insn *insn ATTRIBUTE_UNUSED;

  if (num_delay_slots (delay_insn) == 0)
    return 0;
  gcc_assert (slot < 0);

  if (!INSN_P (candidate_insn))
    return 0;

  insn = candidate_insn;
  switch (slot)
    {
    default:
      gcc_unreachable ();
    }
}

int
eligible_for_annul_true (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
eligible_for_annul_false (rtx_insn *delay_insn ATTRIBUTE_UNUSED,
    int slot ATTRIBUTE_UNUSED,
    rtx_insn *candidate_insn ATTRIBUTE_UNUSED,
    int flags ATTRIBUTE_UNUSED)
{
  return 0;
}

int
const_num_delay_slots (rtx_insn *insn)
{
  switch (recog_memoized (insn))
    {
    default:
      return 1;
    }
}

EXPORTED_CONST int length_unit_log = 2;
